
// WormChase.java
// Andrew Davison, April 2005, ad@fivedots.coe.psu.ac.th

/* A worm moves around the screen and the user must
   click (press) on its head to complete the game.

   If the user misses the worm's head then a blue box
   will be added to the screen (if the worm's body was
   not clicked upon).

   A worm cannot move over a box, so the added obstacles
   *may* make it easier to catch the worm.

   A worm starts at 0 length and increases to a maximum
   length which it keeps from then on.

   A score is displayed on screen at the end, calculated
   from the number of boxes used and the time taken. Less
   boxes and less time mean a higher score.

   -------------
   
   The display includes two textfields for showing the current time
   and number of boxes. The average FPS/UPS values are drawn in
   the game's JPanel.

   Pausing/Resuming/Quiting are controlled via the frame's window
   listener methods.

   Uses active rendering to update the JPanel.

   Using Java's timer: System.currentTimeMillis()
     *  millisecs for the period

   Average FPS / UPS
					20			50			80			100
   Win 98 (work):  19/20       43/50       54/83       57/100
   Win 98 (home):  19/20       39/49       49/82       52/98
   Win 2000:       20/20       50/50       57/83       58/100  // slow machine
   Win XP:         20/20       50/50       83/83      100/100
*/

import java.awt.Container;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;


public class WormChase extends JFrame implements WindowListener
{
  private WormPanel wp;        // where the worm is drawn

  public static void main(String args[])
  { 
    new WormChase();    // ms
  }

  public WormChase()
  { 
	super("The Worm Game");
    
	Container c = getContentPane();    // default BorderLayout used
    wp = new WormPanel();
    c.add(wp, "Center");

    addWindowListener( this );
    pack();
    setResizable(false);
    setVisible(true);
  }  // end of WormChase() constructor

  // ----------------- window listener methods -------------

  public void windowActivated(WindowEvent e) 
  { /* wp.resumeGame(); */ }

  public void windowDeactivated(WindowEvent e) 
  { /* wp.pauseGame(); */ }

  public void windowDeiconified(WindowEvent e) 
  {  wp.resumeGame();  }

  public void windowIconified(WindowEvent e) 
  {  wp.pauseGame(); }


  public void windowClosing(WindowEvent e)
  {  wp.stopGame();  }

  public void windowClosed(WindowEvent e) {}
  public void windowOpened(WindowEvent e) {}

} // end of WormChase class


